﻿using System.Text;
using TFSBugTracking;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Xml.Serialization;
using System.Xml;
using System.IO;

namespace TFSTest.TFSBugTracking
{
    
    
    /// <summary>
    ///This is a test class for ProjectBugMappingTest and is intended
    ///to contain all ProjectBugMappingTest Unit Tests
    ///</summary>
    [TestClass()]
    public class ProjectBugMappingTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


       
        [TestMethod()]
        public void SerializeDefaultMapping2XmlFileOnDesktop()
        {      
            var mappings  = ProjectBugMap.GetMappings();
            XmlSerializer xs = new XmlSerializer(mappings.GetType());
            string path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Desktop),"TfsMappings.xml");
            XmlTextWriter xt = new XmlTextWriter(path,Encoding.UTF8);
            xt.Formatting = Formatting.Indented;
            xs.Serialize(xt,mappings);
        }

        [TestMethod()]
        [DeploymentItem("TfsMappings.xml")]
        public void DeSerializeDefaultMappingFromOlderUnitTest()
        {
                  Assert.AreEqual(6, ProjectBugMap.GetMappings("TfsMappings.xml").Length);
        }
    }
}
