﻿using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using TFSBugTracking;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace TFSTest.TFSBugTracking
{
    
    
    /// <summary>
    ///This is a test class for TfsImpersonationMapTest and is intended
    ///to contain all TfsImpersonationMapTest Unit Tests
    ///</summary>
    [TestClass()]
    public class TfsImpersonationMapTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetMappings
        ///</summary>
        [TestMethod()]
        public void GetMappingsTest()
        {

            var mappings = TfsImpersonationMap.GetMappings();

            XmlSerializer xs = new XmlSerializer(mappings.GetType());
            string path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Desktop), "UserMappings.xml");
            XmlTextWriter xt = new XmlTextWriter(path, Encoding.UTF8);
            xt.Formatting = Formatting.Indented;
            xs.Serialize(xt, mappings);
        }
    }
}
